#ifndef IATK_LIBCONST_H
#define IATK_LIBCONST_H
/*** Copyright ****************************************************************/
/*                                                                            */
/* IBM Agent Building Environment                                             */
/*                                                                            */
/* (C) Copyright IBM Corp. 1996                                               */
/* All Rights Reserved.                                                       */
/*                                                                            */
/* Licensed Materials - Property of IBM                                       */
/*                                                                            */
/* US Government Users Restricted Rights - Use, duplication or                */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.          */
/*                                                                            */
/******************************************************************************/

//******************************************************************************
//
// FILE:    src/library/c/libconst.h, tk_library, abe.l6
// VERSION: 1.4 97/06/19 18:11:05
//
// INCLUDE AS:  #include <iatk/libconst.h>
//
// PURPOSE:  Define IALib constants.
//
// DESCRIPTION:
//    The various constants used by the IALib... classes.
//
// CLASSES DECLARED:
//    None
//
// NOTES:
//
//******************************************************************************

//** Version History ***********************************************************
//
// FLG   DATE   WHO REASON DESCRIPTION
// ---   ------ --- ------ -----------
// $xn = yymmdd iii pnnnnn (abstract of feature/defect)
// $a1 = 970519 jeg F00813 Support for Microsoft Visual C++ compiler
//
//******************************************************************************

#include <iatk/types.h>

#ifndef IATK_CURSORSCOPE
#define IATK_CURSORSCOPE
   enum IALibInferenceCollectorCursorScope  // Cursor scope
            {IALibICCS_all, IALibICCS_collectors, IALibICCS_rulesets,
             IALibICCS_ltfactsets, IALibICCS_logsets};
#endif

#ifndef IATK_CETYPE
#define IATK_CETYPE
      enum IALibInferenceContentsElementType  // Contents Element types
              {IALibICET_collector='a', IALibICET_collectormetadata='b', IALibICET_ruleset='c',
               IALibICET_rulesetmetadata='d', IALibICET_ltfactset='e', IALibICET_ltfactsetmetadata='f',
               IALibICET_rulesmetadata='g', IALibICET_ltfactsmetadata='h', IALibICET_logset='i',
               IALibICET_ceunknown='u'};

const char nometadataname = ' ';     // Blank metadataname means no metadata file
#endif

#ifndef IATK_RULECONSTANTS
#define IATK_RULECONSTANTS
char* const ACTIVER = "A";                 // Rule is active
char* const INACTIVER = "I";               // Rule is inactive
const IABool DELETEDR = 1;                 // Rule deleted                                              //$a1
const IABool NOTDELETEDR = 0;              // Rule not deleted                                          //$a1
#endif

#ifndef IATK_RULESETCONSTANTS
#define IATK_RULESETCONSTANTS
char* const ACTIVERS = "A";  	     // Active RuleSet
char* const INACTIVERS = "I";      // Inactive RuleSet
#endif

#ifndef IATK_LTFACTCONSTANTS
#define IATK_LTFACTCONSTANTS
char* const ACTIVEF = "A";                 // LTFact is active
char* const INACTIVEF = "I";               // LTFact is inactive
const IABool DELETEDF = 1;                 // LTFact deleted                                             //$a1
const IABool NOTDELETEDF = 0;              // LTFact not deleted                                         //$a1
#endif

#ifndef IATK_LTFACTSETCONSTANTS
#define IATK_LTFACTSETCONSTANTS
char* const ACTIVEFS = "A";  	     // Active LTFactSet
char* const INACTIVEFS = "I";      // Inactive LTFactSet
#endif

#ifndef IATK_LOGRECTYPES
#define IATK_LOGRECTYPES
// Sample Log Record types
const unsigned int IALibLRT_none = 0;
const unsigned int IALibLRT_activity_normal = 1;
const unsigned int IALibLRT_error = 2;
const unsigned int IALibLRT_information = 4;
const unsigned int IALibLRT_activity_detail = 8;
#endif

#endif
