#ifndef IATK_LOGKEY_H
#define IATK_LOGKEY_H
/*** Copyright ****************************************************************/
/*                                                                            */
/* IBM Agent Building Environment                                             */
/*                                                                            */
/* (C) Copyright IBM Corp. 1996                                               */
/* All Rights Reserved.                                                       */
/*                                                                            */
/* Licensed Materials - Property of IBM                                       */
/*                                                                            */
/* US Government Users Restricted Rights - Use, duplication or                */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.          */
/*                                                                            */
/******************************************************************************/

//******************************************************************************
//
// FILE:    src/library/c/logkey.h, tk_library, abe.l6
// VERSION: 1.3 97/04/02 13:01:26
//
// INCLUDE AS:  #include <iatk/logkey.h>
//
// PURPOSE:  Define the logKey struct.
//
// DESCRIPTION:
//    A structure of two unsigned integers:
//      1) Block sequence number
//      2) Record position in block
//    Used to uniquely identify a log record in the log record set, particularly
//    used for positioning on log reads and for setting metadata at other than the
//    current cursor position.
//
// CLASSES DECLARED:
//    -
//
//******************************************************************************

//** Version History ***********************************************************
//
// FLG   DATE   WHO REASON DESCRIPTION
// ---   ------ --- ------ -----------
// $xn = yymmdd iii pnnnnn (abstract of feature/defect)
//       961115 tlw F00445 File created
//
//******************************************************************************

struct logKey {   // Unique identifier of a LogRecord in a LogRecordSet
    unsigned int blockSequenceNumber;
    unsigned int recordPositionInBlock;
};
#endif
