/*************************************************************************
** File:         RemMessageVector.java
** Description:  Reminder Message Vector Class used by sample agent for reminders.
**
** DISCLAIMER OF WARRANTIES:
** -------------------------
** The following [enclosed] code is sample code created by IBM
** Corporation.  This sample code is not part of any standard IBM product
** and is provided to you solely for the purpose of assisting you in the
** development of your applications.  The code is provided "AS IS",
** without warranty of any kind.  IBM shall not be liable for any damages
** arising out of your use of the sample code, even if they have been
** advised of the possibility of such damages.
*************************************************************************/
// Description: This class is a container that holds RemMessage objects
//
//-----------------------------------------------------------------------------
package ibm.AgentBuilder.samples.ReminderAgent;
import java.util.Vector;

public class RemMessageVector extends Vector
{
    //-------------------------------------------------------------------------
    // Instance variables
    //-------------------------------------------------------------------------
  boolean debug = false;             // Debug variable

    //-------------------------------------------------------------------------
    // Constructor  (default)
    //-------------------------------------------------------------------------
  public RemMessageVector( )
    {

    }

    //-------------------------------------------------------------------------
    // Method: print()
    //-------------------------------------------------------------------------
  public String print( )
    {
    if ( debug ) System.out.println( "RemMessageVector::print() Enter -->" );
    String     aString = new String(  );

    for ( int i = 0 ; i < elementCount ; i++ )
      {
      if ( debug ) System.out.println( "RemMessageVector::print() in the loop "
                   + "loop count = " + i );
      aString += ((RemMessage) elementAt(i)).print();
      }
    if ( debug ) System.out.println( "RemMessageVector::print() Exit  <--" );
    return( aString );
    }


    //-------------------------------------------------------------------------
    // Method: markAllRead()
    //-------------------------------------------------------------------------
  public void markAllRead( )
    {
    if ( debug ) System.out.println( "RemMessageVector::markAllRead() Enter -->" );
    String     aString = new String(  );

    for ( int i = 0 ; i < elementCount ; i++ )
      {
      if ( debug ) System.out.println( "RemMessageVector::markAllRead() in the loop "
                   + "loop count = " + i );
      ((RemMessage) elementAt(i)).markRead();
      }
    if ( debug ) System.out.println( "RemMessageVector::markAllRead() Exit  <--" );
    }


}
