#ifndef MESSAGE_H
#define MESSAGE_H
/*************************************************************************
** File:         message.h
** Description:  Header file for a library-based message adapter
**
** DISCLAIMER OF WARRANTIES:
** -------------------------
** The following [enclosed] code is sample code created by IBM
** Corporation.  This sample code is not part of any standard IBM product
** and is provided to you solely for the purpose of assisting you in the
** development of your applications.  The code is provided "AS IS",
** without warranty of any kind.  IBM shall not be liable for any damages
** arising out of your use of the sample code, even if they have been
** advised of the possibility of such damages.
*************************************************************************/

#include <iatk/adapter.h>         // IAAdapter class
#include <i0string.hpp>           // I0String class
#include <iatk/library.h>         // library
#include <iatk/collect.h>         // library

#define SETMESSAGE_TOKEN                                  1

// Note: This adapter generates no events and handles no sensors.  Therefore
// the inherited versions of the following member functions provided
// by the IAAdapter class are adequate for this adapter, and are not
// defined here.  See the doc for adapter creation or the header files
// for the IAAdapter class for information on their function and content.
//     start
//     stop
//     shutdown
//     eventComplete
//     testCondition
//     answerQuery

class MessageAdapter : public IAAdapter {
 public:
   MessageAdapter(char * parm);
   ~MessageAdapter();
   IABool IACALLBK identify();
   void IACALLBK performAction(IAProcToken token, const IAEventHeader &hdr,
      const char *binding);

 private:

   IALibrary * myLib;

   IALibInferenceCollector * myCollector;

};  // end of class MessageAdapter
#endif
