// -----------------------------------------------------------------------
// (C) Copyright IBM Corp, 1996
//
// File:        StockClassLoader.java
// Version:     1.0 (sample) 6 August 1996
//
// Description: This class loads an object (specified by the passed class
//              name) and returns a generic referance to it.
//
// DISCLAIMER OF WARRANTIES:
// -------------------------
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM product
// and is provided to you solely for the purpose of assisting you in the
// development of your applications.  The code is provided "AS IS",
// without warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have been
// advised of the possibility of such damages.
// -----------------------------------------------------------------------
package ibm.AgentBuilder.samples.stock;

class StockClassLoader extends ClassLoader {

  //
  StockClassLoader() {
     super();
  }

  //
  public synchronized Class loadClass(String className) throws ClassNotFoundException {
     return loadClass(className, false);

  }

  //
  protected synchronized Class loadClass(String className, boolean resolve) throws ClassNotFoundException {

     Class theClass;

     theClass = findSystemClass(className);

     if (resolve) {
        resolveClass(theClass);
     }
     return theClass;
  }
}
