/*************************************************************************
** (C) Copyright IBM Corp, 1996
**
** File: alarmuid.cpp
**
** DISCLAIMER OF WARRANTIES:
** -------------------------
** The following [enclosed] code is sample code created by IBM
** Corporation.  This sample code is not part of any standard IBM product
** and is provided to you solely for the purpose of assisting you in the
** development of your applications.  The code is provided "AS IS",
** without warranty of any kind.  IBM shall not be liable for any damages
** arising out of your use of the sample code, even if they have been
** advised of the possibility of such damages.
*************************************************************************/
//******************************************************************************
//
// FILE:    src/adapters/timer/alarmuid.cpp, tka_timer, abe.l6
// VERSION: 1.1 97/06/13 11:31:39
//
// PURPOSE:  AlarmUniqueId class implementation
//
// DESCRIPTION:
//     Class used for uniquely identifying alarms
//
// CLASSES IMPLEMENTED:
//    AlarmUniqueId
//
//******************************************************************************

//** Version History ***********************************************************
//
// FLG   DATE   WHO REASON DESCRIPTION
// ===   ====== === ====== ===========
// New   970224 WES  f658  Unique identifiers for sorting alarms
//       970311 WES  f664   Persistent alarms
//******************************************************************************

#include <iapl/common.h>

static char _partid_[] = "@(#) 1.1 src/adapters/timer/alarmuid.cpp, tka_timer, abe.l6";

#include <alarmuid.h>

// 0 indicates persistent Version hasn't been restored yet
int AlarmUniqueId::persistentVersion=0;
const int AlarmUniqueId::version=1;
const AString AlarmUniqueId::classid="uid";


// no other static variables need to be saved?
boolean AlarmUniqueId::versionAdded=
                     PersistentObject::addStaticVars("AlarmUniqueId",
                     &restoreStaticVars,
                     &saveStaticVars);


// only static variable from persistence is currently persistentVersion
boolean AlarmUniqueId::restoreStaticVars(PersistentFile& objectFile)
    {
      if (!objectFile.read(persistentVersion)) return false;
      return objectFile.readEnd();
    }

// only static variable from persistence is currently persistentVersion
boolean AlarmUniqueId::saveStaticVars(PersistentFile& objectFile)
    {
      if (!objectFile.write(version)) return false;
      return objectFile.writeEnd();
    }

