/*  DiscreteVariable class

 Constructing Intelligent Agents with Java
   (C) Joseph P.Bigus and Jennifer Bigus 1997
   

 */


import java.util.*;
import java.io.*;



class DiscreteVariable extends Variable {
Integer min ;
Integer max ;
 
DiscreteVariable(String name) { super(name);
                                labels = new Vector();}

void setMin(Integer Min) { min = Min; }
void setMax(Integer Max) { max = Max; }
 
public void computeStatistics(String inValue){
    if (labels.contains(inValue)) return ;
    else labels.addElement(inValue) ; 
};

 
// translate inValue index into a one-of-N code
public int normalize(String inValue, float[] outArray, int inx) {
    int index = getIndex(inValue) ; // look up symbol index

    float code[] = new float[labels.size()] ;
    if (index < code.length) code[index] = (float)1.0 ;
    // copy one of N code to outArray, increment inx
    for (int i=0 ; i < code.length; i++) {
         outArray[inx++] = code[i] ;
    }
    return inx ;  // return output index
}

public int normalizedSize() { return labels.size() ; }

public String getDecodedValue(float[] act, int start) {
    int len = labels.size() ;
    String value ; 
    float max = (float)-1.0 ; 
    value = String.valueOf(0) ;  
    for (int i=0 ; i < len ; i++) {
        if (act[start+i] > max) {
            max = act[start+i] ;
            value = getLabel(i) ; 
        }
    }
    return value ; 
} 


};
















