/* BasicNegotiation class

   Constructing Intelligent Agents with Java
   (C) Joseph P. Bigus and Jennifer Bigus 1997

*/
// package sunw.demo.ciagent ;
 import java.util.*;

 public class BasicNegotiation  {
   Offer offer ;       // current offer for this item
   long  strikePrice ; // price where we make a deal
   long  lastOffer ;   // last price we offered
   Offer prevOffer ;   // previous offer for this item
   int   iteration ;   // # of back and forth offers

   // used to add items to inventory or wishList
   BasicNegotiation(String item, long strikePrice) {
     offer = new Offer(item) ;
     this.strikePrice = strikePrice ;
     lastOffer = 0 ;
     iteration = 0 ;
   }

   // used for a new negotiation
   BasicNegotiation(Offer offer, long strikePrice) {
     this.offer = offer ;
     lastOffer = 0 ;
     iteration = 0 ;
     strikePrice = strikePrice ;
   }

   public void newOffer(Offer newOffer) {
       prevOffer = offer ;
       offer = newOffer ;
   }

   String getItem() { return offer.item; }
 }
