/* BetterBuyerAgent class

   Constructing Intelligent Agents with Java
   (C) Joseph P. Bigus and Jennifer Bigus 1997

*/
// package sunw.demo.ciagent ;
 import java.util.*;

 public class BetterBuyerAgent extends BuyerAgent {


  public BetterBuyerAgent() { name = "BetterBuyer"; }

  public BetterBuyerAgent(String Name) { super(Name); } ;

  // this method must be overridden to provide alternate
  // negotiation strategies
  void negotiate(Offer offer, CIAgentMessage msg) {

        if (offer.price < current.strikePrice) {
           // accept the offer -- by repeating it to the seller
           CIAgentMessage answer = new CIAgentMessage("make-offer", msg.content , msg.replyWith , msg.sender , offer.item , name) ;
           CIAgentEvent e = new CIAgentEvent(this, answer) ;
           notifyCIAgentEventListeners(e);   // respond through Facilitator
        } else {
          // make a counter offer
          current.lastOffer = offer.price - 50 ;  //
          CIAgentMessage answer = new CIAgentMessage("make-offer", offer.item + " " + offer.id + " " + current.lastOffer, offer.item , msg.sender , offer.item , name) ;

          CIAgentEvent e = new CIAgentEvent(this, answer) ;
          notifyCIAgentEventListeners(e);   // respond through Facilitator
        }
    }

 };
