/* BetterSellerAgent class

   Constructing Intelligent Agents with Java
   (C) Joseph P. Bigus and Jennifer Bigus 1997

*/
// package sunw.demo.ciagent ;
 import java.util.*;

 public class BetterSellerAgent extends SellerAgent {


  public BetterSellerAgent() { name = "BetterSeller"; }

  public BetterSellerAgent(String Name) { super(Name); } ;


  void negotiate(Offer offer, CIAgentMessage msg) {
     if (offer.price >= current.strikePrice) {
            // accept
            CIAgentMessage answer = new CIAgentMessage("accept-offer", msg.content, msg.replyWith , msg.sender , offer.item , name) ;
            CIAgentEvent e = new CIAgentEvent(this, answer) ;
            notifyCIAgentEventListeners(e);   // respond through Facilitator
            return ;
     }
     if (offer.price < current.strikePrice) {
        long spread = current.strikePrice - offer.price ;
        if (spread > 50 ) {   // reject
           CIAgentMessage answer = new CIAgentMessage("reject-offer", msg.content , msg.replyWith , msg.sender , offer.item , name) ;
           CIAgentEvent e = new CIAgentEvent(this, answer) ;
           notifyCIAgentEventListeners(e);   // respond through Facilitator
        } else {                  // counter offer at strike price
           CIAgentMessage answer = new CIAgentMessage("make-offer", offer.item + " " + offer.id + " " + current.strikePrice , msg.replyWith , msg.sender , offer.item , name) ;
           CIAgentEvent e = new CIAgentEvent(this, answer) ;
           notifyCIAgentEventListeners(e);   // respond through Facilitator
        }
        return ;
     }
  }

 };
