/*  EffectorClause class

  Constructing Intelligent Agents with Java
   (C) Joseph P. Bigus and Jennifer Bigus 1997

*/

import java.util.*;
import java.io.*;


public class EffectorClause extends Clause {
    Effector object ;       // object to call
    String effectorName ; // method to call
    String arguments ;  // parameters to pass
    EffectorClause(String eName, String args)
    {
     ruleRefs = new Vector() ;
     truth = new Boolean(true);    // always true
     consequent = new Boolean(true);  // must be consequent
     effectorName = eName ;
     arguments = args ;
    }

    public String display() {
        return "effector(" + effectorName + "," + arguments + ") " ;
    }

     // call the effector method on the target object
    Boolean perform(RuleBase rb) {
         object = (Effector)(rb.getEffectorObject(effectorName)) ;
         object.effector(this, effectorName, arguments) ;
         return truth ;  // always true

    }

};





