/* Fact class

   Constructing Intelligent Agents with Java
   (C) Joseph P.Bigus and Jennifer Bigus 1997

 */

import java.util.*;
import java.io.*;
import java.awt.* ;

public class Fact {
  RuleBase rb ;
  String name ;
  Clause fact ;     //only 1 clause allowed
  Boolean truth;       // states = (null=unknown, true, or false)
  boolean fired=false;
  Fact(RuleBase Rb, String Name, Clause f) {
    rb = Rb ;
    name = Name ;
    fact = f ;
    rb.addFact(this) ;  // add self to fact list
    truth = null ;
  }




  // assert the fact
  public void assert(RuleBase rb) {
   if (fired == true) return ; // only assert once

   RuleBase.trace("\nAsserting fact " + name ) ;
   truth = new Boolean(true) ;
   fired = true ;
   if (fact.lhs == null) {
      // it's an effector
      ((EffectorClause)fact).perform(rb) ;  // call the effector method
   } else {
      // set the variable value and update clauses
      fact.lhs.setValue(fact.rhs) ;
      // now retest any rules whose clauses just changed

   }
 }


  // display the fact in text format
  void display(TextArea textArea) {
    textArea.append(name +": ") ;
    textArea.append(fact.display() + "\n") ;
  }

};






