/* QuitDialog class

   Constructing Intelligent Agents with Java
   (C) Joseph P. Bigus and Jennifer Bigus 1997


 */

import java.awt.*;

public class QuitDialog extends Dialog {
	void yesButton_Clicked(java.awt.event.ActionEvent event) {
	    dispose() ;
	    System.exit(0); 
	}

	void noButton_Clicked(java.awt.event.ActionEvent event) {
		//{{CONNECTION
		// Clicked from noButton Hide the Dialog
		dispose();
		//}}
	}

	public QuitDialog(Frame parent, boolean modal) {

	    super(parent, modal);

		//{{INIT_CONTROLS
		setLayout(null);
		setLocation(parent.getLocation().x + 100, parent.getLocation().y + 100) ;
		setSize(getInsets().left + getInsets().right + 337,getInsets().top + getInsets().bottom + 135);
		yesButton = new java.awt.Button(" Yes ");
		yesButton.setBounds(getInsets().left + 72,getInsets().top + 84,79,22);
		yesButton.setFont(new Font("Dialog", Font.BOLD, 12));
		add(yesButton);
		noButton = new java.awt.Button("  No  ");
		noButton.setBounds(getInsets().left + 180,getInsets().top + 84,79,22);
		noButton.setFont(new Font("Dialog", Font.BOLD, 12));
		add(noButton);
		label1 = new java.awt.Label("Do you really want to quit?");
		label1.setBounds(getInsets().left + 48,getInsets().top + 36,252,23);
		add(label1);
		setTitle("A CIAgent Application - Quit");
		setResizable(false);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		noButton.addActionListener(lSymAction);
		yesButton.addActionListener(lSymAction);
		this.addWindowListener(new windowEvents());
		//}}
	}

	public QuitDialog(Frame parent, String title, boolean modal) {
	    this(parent, modal);
	    setTitle(title);
	}

   
 //-------------------------------------------------------------
 // This file has been migrated from the 1.0 to 1.1 event model.
 // This method is not used with the new 1.1 event model. You can 
 // move any code you need to keep, then remove this method.
 //-------------------------------------------------------------
 // 
 // 	public boolean handleEvent(Event event) {
 // 	    if(event.id == Event.WINDOW_DESTROY) {
 // 	        hide();
 // 	        return true;
 // 	    }
 // 		if (event.target == noButton && event.id == Event.ACTION_EVENT) {
 // 			noButton_Clicked(event);
 // 		}
 // 		if (event.target == yesButton && event.id == Event.ACTION_EVENT) {
 // 			yesButton_Clicked(event);
 // 		}
 // 		return super.handleEvent(event);
 // 	}
 //-------------------------------------------------------------

	//{{DECLARE_CONTROLS
	java.awt.Button yesButton;
	java.awt.Button noButton;
	java.awt.Label label1;
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == noButton)
				noButton_Clicked(event);
			else if (object == yesButton)
				yesButton_Clicked(event);
		}
	}
	
	class windowEvents extends java.awt.event.WindowAdapter {
        public void windowClosing(java.awt.event.WindowEvent event) {
               dispose() ;
        }     
    }     
}
