/* CIAgent class

   Constructing Intelligent Agents with Java
   (C) Joseph P. Bigus and Jennifer Bigus 1997

*/
//package sunw.demo.ciagent ;

 import java.util.*;
 import java.awt.*;
 import java.beans.* ;


 public class CIAgent implements CIAgentEventListener, Runnable {

  private Vector listeners = new Vector() ; // list of listeners

  public synchronized void
    addCIAgentEventListener(CIAgentEventListener ciaEventListener) {
           listeners.addElement(ciaEventListener) ;
  }

  public synchronized void
    removeCIAgentEventListener(CIAgentEventListener ciaEventListener) {
           listeners.removeElement(ciaEventListener) ;
  }

  protected void notifyCIAgentEventListeners() {
     Vector l ;
     CIAgentEvent e = new CIAgentEvent(this) ;

     synchronized(this) { l = (Vector)listeners.clone(); }
     for (int i=0 ; i < l.size() ; i++) { // deliver the event
       ((CIAgentEventListener)l.elementAt(i)).ciaEventFired(e);
     }
  }

  // deliver the ciagent event to registered listeners
  protected void notifyCIAgentEventListeners(CIAgentEvent e) {
     Vector l ;
     synchronized(this) { l = (Vector)listeners.clone(); }
     for (int i=0 ; i < l.size() ; i++) { // deliver the event
       ((CIAgentEventListener)l.elementAt(i)).ciaEventFired(e);
     }
  }

  public  void ciaEventFired(CIAgentEvent e) {
      System.out.println("CIAgent: CIAgentEvent received by " + name +
                         " from " + e.getSource() + " with args " + e.getArgObject()) ;
  }

  String name ;          // the agent's name
  public String getName() { return name ; }
  public void setName(String Name) {
    String oldName = name ;
    name = Name ;
    changes.firePropertyChange("name", oldName, name);
  }

  private PropertyChangeSupport changes = new PropertyChangeSupport(this);

  public CIAgent() { name = "CIAgent"; }
  public CIAgent(String Name) { name = Name ;
                       }
  // used for tracing and display of agent status
  Object market ;
  int traceLevel=0 ;   //  0 = summary, 1 = detailed
  TextArea textArea ;
  public void setDisplay(Object mkt, int trace) {
    market = mkt ;  traceLevel = trace ;
  }
  public synchronized void trace(String msg) {
    // comment this line out if using this outside Marketplace app
//    if (market != null) ((Marketplace)market).trace(msg) ;
    if (textArea != null) textArea.append(msg) ;
  }


  public void process() {};   // perform the major processing function

  public  void reset() {};   // reset the agent to a known state

  public  void initialize() {};  // initialize the agent for processing

  // required by Runnable interface and Threads
  Thread runnit = new Thread(); // start()ed in the process() method
  boolean stopped = false; // control flag
  public void stop() {} ;  // stop the agent thread
  public void run() {} ;   // body of thread


};

