/* KeywordDialog class

   Constructing Intelligent Agents with Java
   (C) Joseph P.Bigus and Jennifer Bigus 1997

 */

import java.awt.*;

public class KeywordDialog extends Dialog {
    // Cancel
	void button2_Clicked(java.awt.event.ActionEvent event) {

		//{{CONNECTION
		// Hide the Dialog
		dispose();
		//}}
	}

    // OK
	void button1_Clicked(java.awt.event.ActionEvent event) {


		//{{CONNECTION
		// Hide the Dialog
		dispose();
		//}}
	}

    // Remove
	void button4_Clicked(java.awt.event.ActionEvent event) {
	 	// Delete an item from the List... Get the current item index
		if (list1.getSelectedItem() != null) {
		  list1.delItem(list1.getSelectedIndex());
		}
	 }

    // Add
	void button3_Clicked(java.awt.event.ActionEvent event) {

 		// Add a string to the List... Get the contents of the TextField
		if (textField1.getText().length() > 0) {
		  list1.addItem(textField1.getText());
        }
 	}


	public KeywordDialog(Frame parent, boolean modal) {

	    super(parent, modal);

		//{{INIT_CONTROLS
		setLayout(null);
		setLocation(parent.getLocation().x + 100, parent.getLocation().y + 100);
		setSize(getInsets().left + getInsets().right + 382,getInsets().top + getInsets().bottom + 379);
		list1 = new java.awt.List(0,false);
		add(list1);
		list1.setBounds(getInsets().left + 36,getInsets().top + 84,180,182);
		label1 = new java.awt.Label("Key word");
		label1.setBounds(getInsets().left + 36,getInsets().top + 24,132,18);
		add(label1);
		button2 = new java.awt.Button("Cancel");
		button2.setBounds(getInsets().left + 216,getInsets().top + 324,118,36);
		add(button2);
		button3 = new java.awt.Button("add");
		button3.setBounds(getInsets().left + 252,getInsets().top + 84,106,36);
		add(button3);
		button4 = new java.awt.Button("remove");
		button4.setBounds(getInsets().left + 252,getInsets().top + 192,105,36);
		add(button4);
		textField1 = new java.awt.TextField();
		textField1.setBounds(getInsets().left + 36,getInsets().top + 48,174,24);
		add(textField1);
		button1 = new java.awt.Button("OK");
		button1.setBounds(getInsets().left + 48,getInsets().top + 324,111,36);
		add(button1);
		setTitle("Dialog3");
		setResizable(false);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		button3.addActionListener(lSymAction);
		button4.addActionListener(lSymAction);
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		this.addWindowListener(new windowEvents());
		//}}
	}

	public KeywordDialog(Frame parent, String title, boolean modal) {
	    this(parent, modal);
	    setTitle(title);
	}

  
 //-------------------------------------------------------------
 // This file has been migrated from the 1.0 to 1.1 event model.
 // This method is not used with the new 1.1 event model. You can
 // move any code you need to keep, then remove this method.
 //-------------------------------------------------------------
 //
 // 	public boolean handleEvent(Event event) {
 // 	    if(event.id == Event.WINDOW_DESTROY) {
 // 	        hide();
 // 	        return true;
 // 	    }
 // 		if (event.target == button3 && event.id == Event.ACTION_EVENT) {
 // 			button3_Clicked(event);
 // 			return true;
 // 		}
 // 		if (event.target == button4 && event.id == Event.ACTION_EVENT) {
 // 			button4_Clicked(event);
 // 			return true;
 // 		}
 // 		if (event.target == button1 && event.id == Event.ACTION_EVENT) {
 // 			button1_Clicked(event);
 // 			return true;
 // 		}
 // 		if (event.target == button2 && event.id == Event.ACTION_EVENT) {
 // 			button2_Clicked(event);
 // 			return true;
 // 		}
 // 		return super.handleEvent(event);
 // 	}
 //-------------------------------------------------------------

	//{{DECLARE_CONTROLS
	java.awt.List list1;
	java.awt.Label label1;
	java.awt.Button button2;
	java.awt.Button button3;
	java.awt.Button button4;
	java.awt.TextField textField1;
	java.awt.Button button1;
	//}}

	String[] keywords ;

	void setKeywords(String[] keys) {
	    keywords = keys ;
	    list1.removeAll() ;
	    for (int i=0 ; i < keys.length ; i++) {
	        list1.addItem(keys[i]) ;
	    }
	}

	String[] getKeywords() {
	    keywords = list1.getItems() ;
	   return keywords ;
	}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button3)
				button3_Clicked(event);
			else if (object == button4)
				button4_Clicked(event);
			else if (object == button1)
				button1_Clicked(event);
			else if (object == button2)
				button2_Clicked(event);
		}
	}
	
	class windowEvents extends java.awt.event.WindowAdapter {
        public void windowClosing(java.awt.event.WindowEvent event) {
               dispose();
        }     
    }     
}
