/* NewsArticle class

   Constructing Intelligent Agents with Java
   (C) Joseph P. Bigus and Jennifer Bigus 1997

 */
import java.io.* ;

public class NewsArticle {
    String id ;  // numeric article ID -- valid only for this server
    String subject ;   // subject line from header
    String body ;      // body or text of news posting
    int    counts[] ;  // raw counts of keys in body
    int    sum ;       // sum of raw counts
    double feedback=0.5 ;   // 0=neg, 0.5=neutral, 1.0=pos
    double score ;   // match score or ranking
    int clusterId;   // cluster this article falls into
    NewsArticle(String id) {  this.id = id ; }

    void readArticle(String fileName) {
     File f = new File(fileName) ;
     int size = (int) f.length();
     int bytesRead = 0 ;
     try {
       FileInputStream in = new FileInputStream(f) ;

       byte[] data = new byte[size] ;
       in.read(data, 0, size);
       subject = "Subject: " + fileName  ;
       body = new String(data) ;
       id = fileName ;
       in.close() ;
     }
     catch (IOException e) {
         System.out.println("Error: couldn't read news article from " + fileName + "\n") ;
     }
    }

    void writeArticle(String fileName) {
     File f = new File(fileName) ;
     String dataOut = subject + " " + body ;
     int size = (int) dataOut.length();
     int bytesOut = 0 ;
     byte data[] = new byte[size] ;
     data = body.getBytes() ;  // jpb for jdk 1,1,6
     try {
       FileOutputStream out = new FileOutputStream(f) ;
       out.write(data, 0, size);
       out.flush() ;
       out.close() ;
     }
     catch (IOException e) {
        System.out.println("Error: couldn't write news article to " + fileName + "\n");
     }
    }


    // return the profile data as a string for writing out
    String getProfileString() {

     StringBuffer outString = new StringBuffer("") ;
     for (int i = 0 ; i < counts.length ; i++) {
        outString.append(counts[i]) ;
        outString.append(" ") ;
     }
     outString.append(feedback) ;
     outString.append(" ") ;
     outString.append(score) ;


     return outString.toString() ;
    }
}