/* AboutPCManagerDialog Class

  Constructing Intelligent Agents with Java
   (C) Joseph P. Bigus and Jennifer Bigus 1997 

 Copyright (c) 1998 John Wiley & Sons, Inc.  All rights reserved.  
 Reproduction or translation of this work beyond that permitted in 
 Section 117 of the 1976 United States Copyright Act without the 
 express written permission of the copyright owner is unlawful.  
 Requests for further information should be addressed to Permissions 
 Department, John Wiley & Sons, Inc. The purchaser may make back-up 
 copies for his/her own use only and not for distribution or resale.
 The Publisher assumes no responsibility for errors, omissions, or 
 damages, caused by the use of these programs or from the use of the 
 information contained herein.

*/

import java.awt.*;

public class AboutPCManagerDialog extends Dialog {
	void okButton_Clicked(java.awt.event.ActionEvent event) {
		//{{CONNECTION
		// Clicked from okButton Hide the Dialog
		dispose();
		//}}
	}

	public AboutPCManagerDialog(Frame parent, boolean modal) {

	    super(parent, modal);

		//{{INIT_CONTROLS
		setLayout(null);
		setLocation(parent.getLocation().x + 100, parent.getLocation().y + 100);
		setSize(getInsets().left + getInsets().right + 341,getInsets().top + getInsets().bottom + 150);
		label1 = new java.awt.Label("CIAgent PC Manager Application");
		label1.setBounds(getInsets().left + 36,getInsets().top + 24,252,21);
		add(label1);
		okButton = new java.awt.Button("OK");
		okButton.setBounds(getInsets().left + 132,getInsets().top + 108,66,27);
		add(okButton);
		label2 = new java.awt.Label("(c) Joseph P. and Jennifer Bigus 1997");
		label2.setBounds(getInsets().left + 24,getInsets().top + 60,300,24);
		add(label2);
		setTitle("About");
		setResizable(false);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		okButton.addActionListener(lSymAction);
		this.addWindowListener(new windowEvents());
		//}}
	}

	public AboutPCManagerDialog(Frame parent, String title, boolean modal) {
	    this(parent, modal);
	    setTitle(title);
	}

  
 //-------------------------------------------------------------
 // This file has been migrated from the 1.0 to 1.1 event model.
 // This method is not used with the new 1.1 event model. You can 
 // move any code you need to keep, then remove this method.
 //-------------------------------------------------------------
 // 
 // 	public boolean handleEvent(Event event) {
 // 	    if(event.id == Event.WINDOW_DESTROY) {
 // 	        hide();
 // 	        return true;
 // 	    }
 // 		if (event.target == okButton && event.id == Event.ACTION_EVENT) {
 // 			okButton_Clicked(event);
 // 		}
 // 		return super.handleEvent(event);
 // 	}
 //-------------------------------------------------------------

	//{{DECLARE_CONTROLS
	java.awt.Label label1;
	java.awt.Button okButton;
	java.awt.Label label2;
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okButton)
				okButton_Clicked(event);
		}
	}
	
	class windowEvents extends java.awt.event.WindowAdapter {
        public void windowClosing(java.awt.event.WindowEvent event) {
               dispose() ;
        }     
    }     
}
