/* PC Manager Alarm Dialog Class

  Constructing Intelligent Agents with Java
   (C) Joseph P. Bigus and Jennifer Bigus 1997

 */

import java.awt.*;
import java.util.* ;

public class AlarmDialog extends Dialog {

    // Cancel
	void button2_Clicked(java.awt.event.ActionEvent event) {


		//{{CONNECTION
		// Hide the Dialog
		dispose();
		//}}
	}

    // OK
	void button1_Clicked(java.awt.event.ActionEvent event) {

        String name = textField4.getText() ;
        agent = new TimerAgent(name) ;

        if (radioButton1.getState() == true) {
            // one time
            String time = textField2.getText() ;
            StringTokenizer tok = new StringTokenizer(time,":") ;
            int hour = new Integer(tok.nextToken()).intValue() ;
            int min = new Integer(tok.nextToken()).intValue() ;
            Calendar now = Calendar.getInstance() ;
            now.set(Calendar.HOUR, hour) ;
            now.set(Calendar.MINUTE,min) ;
            agent.setTime(now.getTime()) ; // pass Date object
        } else {
            // interval
            String interval = textField3.getText() ;
            agent.setInterval(new Integer(interval).intValue()) ;
        }
        int action = choice2.getSelectedIndex() ;
        agent.setAction(action) ;
        if (action == 0) agent.setDialog(new AlertDialog((Frame)this.getParent(),name + ": Alert", false)) ;
        if (action == 1) agent.setDialog(new ExecuteDialog((Frame)this.getParent(),name + ": Execute", false)) ;

        String parms = textField1.getText() ;
        agent.setParms(parms) ;



		//{{CONNECTION
		// Hide the Dialog
		dispose();
		//}}
	}


	public AlarmDialog(Frame parent, boolean modal) {

	    super(parent, modal);

		//{{INIT_CONTROLS
		setLayout(null);
		setLocation(parent.getLocation().x + 100, parent.getLocation().y + 50);
		setSize(getInsets().left + getInsets().right + 433,getInsets().top + getInsets().bottom + 360);
		setBackground(new Color(12632256));
		label3 = new java.awt.Label("Action");
		label3.setBounds(getInsets().left + 48,getInsets().top + 228,84,36);
		add(label3);
		label4 = new java.awt.Label("Parameters");
		label4.setBounds(getInsets().left + 36,getInsets().top + 264,108,24);
		add(label4);
		textField1 = new java.awt.TextField();
		textField1.setBounds(getInsets().left + 156,getInsets().top + 264,240,29);
		add(textField1);
		label5 = new java.awt.Label("Interval");
		label5.setBounds(getInsets().left + 84,getInsets().top + 168,96,24);
		add(label5);
		choice2 = new java.awt.Choice();
		choice2.addItem("Alert");
		choice2.addItem("Execute");
		choice2.addItem("Fire CIAgent Event");
		add(choice2);
		choice2.setBounds(getInsets().left + 156,getInsets().top + 228,134,24);
		label2 = new java.awt.Label("Time");
		label2.setBounds(getInsets().left + 84,getInsets().top + 96,89,24);
		label2.setBackground(new Color(12632256));
		add(label2);
		Group1 = new CheckboxGroup();
		radioButton1 = new java.awt.Checkbox("One Time", Group1, false);
		radioButton1.setBounds(getInsets().left + 24,getInsets().top + 72,147,17);
		add(radioButton1);
		radioButton2 = new java.awt.Checkbox("Repeating", Group1, false);
		radioButton2.setBounds(getInsets().left + 24,getInsets().top + 144,126,20);
		add(radioButton2);
		textField2 = new java.awt.TextField();
		textField2.setBounds(getInsets().left + 216,getInsets().top + 96,127,26);
		add(textField2);
		textField3 = new java.awt.TextField();
		textField3.setBounds(getInsets().left + 216,getInsets().top + 168,124,27);
		add(textField3);
		label6 = new java.awt.Label("seconds");
		label6.setBounds(getInsets().left + 348,getInsets().top + 168,84,26);
		label6.setBackground(new Color(12632256));
		add(label6);
		button2 = new java.awt.Button("Cancel");
		button2.setBounds(getInsets().left + 252,getInsets().top + 312,84,24);
		add(button2);
		label7 = new java.awt.Label("Name");
		label7.setBounds(getInsets().left + 24,getInsets().top + 30,152,28);
		add(label7);
		textField4 = new java.awt.TextField();
		textField4.setBounds(getInsets().left + 180,getInsets().top + 30,134,26);
		add(textField4);
		button1 = new java.awt.Button("OK");
		button1.setBounds(getInsets().left + 108,getInsets().top + 312,84,24);
		add(button1);
		label8 = new java.awt.Label("hh:mm");
		label8.setBounds(getInsets().left + 348,getInsets().top + 96,78,24);
		add(label8);
		setTitle("");
		setResizable(false);
		//}}

		textField4.setText("Alarm") ;
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		this.addWindowListener(new windowEvents());
		//}}
	}

	public AlarmDialog(Frame parent, String title, boolean modal) {
	    this(parent, modal);
	    setTitle(title);
	}

  
 //-------------------------------------------------------------
 // This file has been migrated from the 1.0 to 1.1 event model.
 // This method is not used with the new 1.1 event model. You can 
 // move any code you need to keep, then remove this method.
 //-------------------------------------------------------------
 // 
 // 	public boolean handleEvent(Event event) {
 // 	    if(event.id == Event.WINDOW_DESTROY) {
 // 	        hide();
 // 	        return true;
 // 	    }
 // 		if (event.target == button1 && event.id == Event.ACTION_EVENT) {
 // 			button1_Clicked(event);
 // 			return true;
 // 		}
 // 		if (event.target == button2 && event.id == Event.ACTION_EVENT) {
 // 			button2_Clicked(event);
 // 			return true;
 // 		}
 // 		return super.handleEvent(event);
 // 	}
 //-------------------------------------------------------------

	//{{DECLARE_CONTROLS
	java.awt.Label label3;
	java.awt.Label label4;
	java.awt.TextField textField1;
	java.awt.Label label5;
	java.awt.Choice choice2;
	java.awt.Label label2;
	java.awt.Checkbox radioButton1;
	CheckboxGroup Group1;
	java.awt.Checkbox radioButton2;
	java.awt.TextField textField2;
	java.awt.TextField textField3;
	java.awt.Label label6;
	java.awt.Button button2;
	java.awt.Label label7;
	java.awt.TextField textField4;
	java.awt.Button button1;
	java.awt.Label label8;
	//}}

	protected TimerAgent agent ;

	TimerAgent getAgent() { return agent; }

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_Clicked(event);
			else if (object == button2)
				button2_Clicked(event);
		}
	}
	
	class windowEvents extends java.awt.event.WindowAdapter {
        public void windowClosing(java.awt.event.WindowEvent event) {
               dispose() ;
        }     
    }     
}
