/* PC Manager Application Class

  Constructing Intelligent Agents with Java
   (C) Joseph P. Bigus and Jennifer Bigus 1997

   Modified: 8/14/98 jpb convert to 1.1 Event model
 */

import java.awt.*;
import java.util.* ;

public class PCManager extends Frame {
	void Alarm_Action(java.awt.event.ActionEvent event) {


		//{{CONNECTION
		// Create with title, show as modal...
		AlarmDialog dlg = new AlarmDialog(this, "Create Alarm", true);
		//}}
		dlg.show() ;
		TimerAgent agent = dlg.getAgent() ;
		if (agent != null) {
          alarms.put(agent.name, agent) ;
          list1.addItem(agent.getDisplayString()) ;
          agent.textArea = textArea1 ;
          agent.process() ;
		}
	}

	void Watch_Action(java.awt.event.ActionEvent event) {

		//{{CONNECTION
		// Create with title, show as modal...
		WatchDialog dlg = new WatchDialog(this, "Create Watch", true);
		//}}
		dlg.show() ;
		FileAgent agent = dlg.getAgent() ;
		if (agent != null) {
          watches.put(agent.name, agent) ;
          list1.addItem(agent.getDisplayString()) ;
          agent.textArea = textArea1 ;
          agent.process() ;
		}
	}


	void Open_Action(java.awt.event.ActionEvent event) {
		//{{CONNECTION
		// Action from Open... Show the OpenFileDialog
		openFileDialog1.show();
		//}}
	}

    void Cut_Action(java.awt.event.ActionEvent event) {

          int index = list1.getSelectedIndex() ;
          if (index < 0) return ;  // no item selected
          String item = list1.getSelectedItem() ;
          list1.delItem(index) ; // remove from list

          StringTokenizer tok = new StringTokenizer(item," ") ;
          String itemName = tok.nextToken() ;
          // remove it from the hashtable
          // and stop the agent thread
          if (watches.containsKey(itemName)) {
            FileAgent watch = (FileAgent)watches.remove(itemName) ;
            watch.stop() ;  // halt the agent
          } else if (alarms.containsKey(itemName)) {
            TimerAgent alarm = (TimerAgent)alarms.remove(itemName) ;
            alarm.stop() ;
          }

 	}

	void About_Action(java.awt.event.ActionEvent event) {
		//{{CONNECTION
		// Action from About Create and show as modal
		(new AboutPCManagerDialog(this, true)).show();
		//}}
	}

	void Exit_Action(java.awt.event.ActionEvent event) {
		//{{CONNECTION
		// Action from Exit Create and show as modal
		(new QuitDialog(this, true)).show();
		//}}
	}

	public PCManager() {

		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(397,332);
    setLocation(100,100); 
		setBackground(new Color(16777215));
		openFileDialog1 = new java.awt.FileDialog(this);
		openFileDialog1.setMode(FileDialog.LOAD);
		openFileDialog1.setTitle("Open");
		//$$ openFileDialog1.move(36,276);
		list1 = new java.awt.List(4);
		add(list1);
		list1.setBounds(12,86,372,70);
		list1.setBackground(new Color(16777215));
		textArea1 = new java.awt.TextArea();
		textArea1.setBounds(12,194,374,135);
		add(textArea1);
		label1 = new java.awt.Label("Activity Log");
		label1.setBounds(12,170,196,20);
		add(label1);
		label2 = new java.awt.Label("Watches/Alarms");
		label2.setBounds(12,62,180,20);
		add(label2);
		setTitle("CIAgent PCManager Application");
		setResizable(false);
		//}}

		//{{INIT_MENUS
		mainMenuBar = new java.awt.MenuBar();
		menu1 = new java.awt.Menu("File");
		menu1.add("New");
		miOpen = new java.awt.MenuItem("Open...");
		menu1.add(miOpen);
		menu1.add("Save");
		menu1.add("Save As...");
		menu1.addSeparator();
		miExit = new java.awt.MenuItem("Exit");
		menu1.add(miExit);
		mainMenuBar.add(menu1);
		menu2 = new java.awt.Menu("Edit");
		miCut = new java.awt.MenuItem("Cut");
		menu2.add(miCut);
		mainMenuBar.add(menu2);
		menu4 = new java.awt.Menu("Create");
		miWatch = new java.awt.MenuItem("Watch...");
		menu4.add(miWatch);
		miAlarm = new java.awt.MenuItem("Alarm...");
		menu4.add(miAlarm);
		mainMenuBar.add(menu4);
		menu3 = new java.awt.Menu("Help");
		mainMenuBar.setHelpMenu(menu3);
		miAbout = new java.awt.MenuItem("About");
		menu3.add(miAbout);
		mainMenuBar.add(menu3);
		setMenuBar(mainMenuBar);
		//$$ mainMenuBar.move(4,277);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		miAlarm.addActionListener(lSymAction);
		miWatch.addActionListener(lSymAction);
		miOpen.addActionListener(lSymAction);
		miAbout.addActionListener(lSymAction);
		miExit.addActionListener(lSymAction);
		miCut.addActionListener(lSymAction);
		this.addWindowListener(new windowEvents());
		//}}
	}

	public PCManager(String title) {
	    this();
	    setTitle(title);
	}

   
 //-------------------------------------------------------------
 // This file has been migrated from the 1.0 to 1.1 event model.
 // This method is not used with the new 1.1 event model. You can 
 // move any code you need to keep, then remove this method.
 //-------------------------------------------------------------
 // 
 // 	public boolean handleEvent(Event event) {
 //     	if (event.id == Event.WINDOW_DESTROY) {
 //             hide();         // hide the Frame
 //             dispose();      // free the system resources
 //             System.exit(0); // close the application
 //             return true;
 //     	}
 // 		return super.handleEvent(event);
 // 	}
 //-------------------------------------------------------------
 //-------------------------------------------------------------
 // This file has been migrated from the 1.0 to 1.1 event model.
 // This method is not used with the new 1.1 event model. You can 
 // move any code you need to keep, then remove this method.
 //-------------------------------------------------------------
 // 
 // 	public boolean action(Event event, Object arg) {
 // 		if (event.target instanceof MenuItem) {
 // 			String label = (String) arg;
 // 			if (label.equalsIgnoreCase("Alarm...")) {
 // 				Alarm_Action(event);
 // 				return true;
 // 			} else
 // 			if (label.equalsIgnoreCase("Watch...")) {
 // 				Watch_Action(event);
 // 				return true;
 // 			} else
 // 			if (label.equalsIgnoreCase("Open...")) {
 // 				Open_Action(event);
 // 				return true;
 // 			} else
 // 			if (label.equalsIgnoreCase("About")) {
 // 				About_Action(event);
 // 				return true;
 // 			} else
 // 				if (label.equalsIgnoreCase("Exit")) {
 // 					Exit_Action(event);
 // 					return true;
 // 			} else
 // 				if (label.equalsIgnoreCase("Cut")) {
 // 					Cut_Action(event);
 // 					return true;
 // 			}
 // 		}
 // 	 	return super.action(event, arg);
 // 	}
 //-------------------------------------------------------------

	static public void main(String args[]) {
	    (new PCManager()).show();
	}

	//{{DECLARE_CONTROLS
	java.awt.FileDialog openFileDialog1;
	java.awt.List list1;
	java.awt.TextArea textArea1;
	java.awt.Label label1;
	java.awt.Label label2;
	//}}

	//{{DECLARE_MENUS
	java.awt.MenuBar mainMenuBar;
	java.awt.Menu menu1;
	java.awt.MenuItem miOpen;
	java.awt.MenuItem miExit;
	java.awt.Menu menu2;
	java.awt.MenuItem miCut;
	java.awt.Menu menu4;
	java.awt.MenuItem miWatch;
	java.awt.MenuItem miAlarm;
	java.awt.Menu menu3;
	java.awt.MenuItem miAbout;
	//}}

	Hashtable watches = new Hashtable() ;
	Hashtable alarms = new Hashtable() ;

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == miAlarm)
				Alarm_Action(event);
			else if (object == miWatch)
				Watch_Action(event);
			else if (object == miOpen)
				Open_Action(event);
			else if (object == miAbout)
				About_Action(event);
			else if (object == miExit)
				Exit_Action(event);
			else if (object == miCut)
				Cut_Action(event);
		}
	}
	class windowEvents extends java.awt.event.WindowAdapter {
        public void windowClosing(java.awt.event.WindowEvent event) {
               System.exit(0) ;
        }     
    }     
}
