/* PC Manager WatchDialog Class

  Constructing Intelligent Agents with Java
   (C) Joseph P. Bigus and Jennifer Bigus 1997

 */

import java.awt.*;

public class WatchDialog extends Dialog {
    // Browse -- open File dialog
	void button1_Clicked(java.awt.event.ActionEvent event) {

        //{{CONNECTION
		// Create with title, show as modal...
		FileDialog dlg = new FileDialog((Frame)this.getParent(), "Select File or Directory", FileDialog.LOAD);
		//}}
        dlg.show() ;
        String dir = dlg.getDirectory() ;
        String fName = dlg.getFile() ;
        textField1.setText(dir+fName) ;

	}

    // cancel
	void button3_Clicked(java.awt.event.ActionEvent event) {

		//{{CONNECTION
		// Hide the Dialog
		dispose();
		//}}
	}

    // OK
	void button2_Clicked(java.awt.event.ActionEvent event) {

        String name = textField4.getText() ;
        agent = new FileAgent(name) ;

        String fileOrDirName = textField1.getText() ;
        agent.setFileName(fileOrDirName) ;

        int cond = choice2.getSelectedIndex() ;
        agent.setCondition(cond) ;
        String threshold = textField2.getText() ;
        if (threshold.length() == 0) threshold = "0" ;
        agent.setThreshold(new Integer(threshold).intValue());

        int action = choice1.getSelectedIndex() ;
        agent.setAction(action) ;
        if (action == 0) agent.setDialog(new AlertDialog((Frame)this.getParent(),name + ": Alert", false)) ;
        if (action == 1) agent.setDialog(new ExecuteDialog((Frame)this.getParent(),name + ": Execute", false)) ;
        String parms = textField3.getText() ;
        agent.setParms(parms) ;


		//{{CONNECTION
		// Hide the Dialog
		dispose();
		//}}
	}


	public WatchDialog(Frame parent, boolean modal) {

	    super(parent, modal);

		//{{INIT_CONTROLS
		setLayout(null);
		setLocation(parent.getLocation().x + 100, parent.getLocation().y + 50);
		setSize(getInsets().left + getInsets().right + 430,getInsets().top + getInsets().bottom + 309);
		setBackground(new Color(12632256));
		label1 = new java.awt.Label("File or Directory");
		label1.setBounds(getInsets().left + 24,getInsets().top + 58,135,24);
		add(label1);
		label2 = new java.awt.Label("Action");
		label2.setBounds(getInsets().left + 24,getInsets().top + 180,144,33);
		add(label2);
		choice1 = new java.awt.Choice();
		choice1.addItem("Alert");
		choice1.addItem("Execute");
		choice1.addItem("Fire CIAgent Event");
		add(choice1);
		choice1.setBounds(getInsets().left + 36,getInsets().top + 216,146,28);
		textField1 = new java.awt.TextField();
		textField1.setBounds(getInsets().left + 24,getInsets().top + 82,204,24);
		add(textField1);
		label3 = new java.awt.Label("Condition");
		label3.setBounds(getInsets().left + 264,getInsets().top + 58,139,25);
		add(label3);
		choice2 = new java.awt.Choice();
		choice2.addItem("Modified");
		choice2.addItem("Deleted");
		choice2.addItem("Over threshold");
		add(choice2);
		choice2.setBounds(getInsets().left + 264,getInsets().top + 82,138,24);
		label4 = new java.awt.Label("Threshold");
		label4.setBounds(getInsets().left + 264,getInsets().top + 118,116,24);
		add(label4);
		textField2 = new java.awt.TextField();
		textField2.setBounds(getInsets().left + 264,getInsets().top + 142,129,24);
		add(textField2);
		button1 = new java.awt.Button("Browse...");
		button1.setBounds(getInsets().left + 24,getInsets().top + 130,117,29);
		add(button1);
		label5 = new java.awt.Label("Parameters");
		label5.setBounds(getInsets().left + 252,getInsets().top + 192,124,19);
		add(label5);
		textField3 = new java.awt.TextField();
		textField3.setBounds(getInsets().left + 264,getInsets().top + 216,144,24);
		add(textField3);
		button2 = new java.awt.Button("OK");
		button2.setBounds(getInsets().left + 108,getInsets().top + 264,72,26);
		add(button2);
		button3 = new java.awt.Button("Cancel");
		button3.setBounds(getInsets().left + 252,getInsets().top + 264,72,24);
		add(button3);
		label6 = new java.awt.Label("Name");
		label6.setBounds(getInsets().left + 24,getInsets().top + 28,142,25);
		add(label6);
		textField4 = new java.awt.TextField();
		textField4.setBounds(getInsets().left + 180,getInsets().top + 28,136,24);
		add(textField4);
		setTitle("");
		setResizable(false);
		//}}

		textField4.setText("Watch") ;  // default name

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		button3.addActionListener(lSymAction);
		this.addWindowListener(new windowEvents());
		//}}
	}

	public WatchDialog(Frame parent, String title, boolean modal) {
	    this(parent, modal);
	    setTitle(title);
	}


 //-------------------------------------------------------------
 // This file has been migrated from the 1.0 to 1.1 event model.
 // This method is not used with the new 1.1 event model. You can 
 // move any code you need to keep, then remove this method.
 //-------------------------------------------------------------
 // 
 // 	public boolean handleEvent(Event event) {
 // 	    if(event.id == Event.WINDOW_DESTROY) {
 // 	        hide();
 // 	        return true;
 // 	    }
 // 	    if (event.target == button1 && event.id == Event.ACTION_EVENT) {
 // 			button1_Clicked(event);
 // 			return true;
 // 		}
 // 		if (event.target == button2 && event.id == Event.ACTION_EVENT) {
 // 			button2_Clicked(event);
 // 			return true;
 // 		}
 // 		if (event.target == button3 && event.id == Event.ACTION_EVENT) {
 // 			button3_Clicked(event);
 // 			return true;
 // 		}
 // 		return super.handleEvent(event);
 // 	}
 //-------------------------------------------------------------

	//{{DECLARE_CONTROLS
	java.awt.Label label1;
	java.awt.Label label2;
	java.awt.Choice choice1;
	java.awt.TextField textField1;
	java.awt.Label label3;
	java.awt.Choice choice2;
	java.awt.Label label4;
	java.awt.TextField textField2;
	java.awt.Button button1;
	java.awt.Label label5;
	java.awt.TextField textField3;
	java.awt.Button button2;
	java.awt.Button button3;
	java.awt.Label label6;
	java.awt.TextField textField4;
	//}}

	protected FileAgent agent ;

	FileAgent getAgent() { return agent ; }

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_Clicked(event);
			else if (object == button2)
				button2_Clicked(event);
			else if (object == button3)
				button3_Clicked(event);
		}
	}
	
	class windowEvents extends java.awt.event.WindowAdapter {
        public void windowClosing(java.awt.event.WindowEvent event) {
               dispose();
        }     
    }     
}
